class Menu_DSL
    attr_accessor :titulos, :ingesta_porcentajes, :platos, :descripcion, :porcion, :gramos, :vct, :proteinas, :grasas, :hidratos
    
    def initialize(titulos, &block)
        self.titulos = titulos
        self.platos = []

        if block_given?  
          if block.arity == 1
            yield self
          else
           instance_eval(&block) 
          end
        end
    end
    
    def titulo (name)
        @titulos = name
    end
    
    def ingesta(options = {})
        min_max = []
        min_max << "#{options[:min]}"
        min_max << "#{options[:max]}"
        @ingesta_porcentajes = min_max
    end
    
    def plato(options = {})
        ingredientes = []
        ingredientes << "#{options[:descripcion]}, #{options[:porcion]}, #{options[:gramos]}"
        @platos.push(ingredientes)
    end
    
    def porcentajes(options = {})
        @vct = "#{options[:vct]}"
        @proteinas = "#{options[:proteinas]}"
        @grasas = "#{options[:grasas]}"
        @hidratos = "#{options[:hidratos]}"
    end

    def to_s
        buffer = "#{@titulos} "
        buffer << "(#{@ingesta_porcentajes.join(' - ')}%)\n"
        buffer << "- #{@platos.join("\n- ")}\n"
        buffer << "V.C.T. | % #{@vct} kcal | #{@proteinas}% - #{@grasas}% - #{@hidratos}%\n"
    end
    
end
